/*
**	Main Test Output Routine
**
** Purpose:
**	Output a stream representing the shippable form
**	of an Object.  This should be readable by an input routine.
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef CONS_HPP
#include "cons.hpp"
#endif /* CONS_HPP */

#ifndef OBJECT_HPP
#include "Object.hpp"
#endif /* OBJECT_HPP */

#ifndef DLIST_HPP
#include "Dlist.hpp"
#endif /* DLIST_HPP */

#ifndef NAME_HPP
#include "Name.hpp"
#endif /* NAME_HPP */

int main()
{
	DPRINT("create testlist");
	Dlist	testlist;		// list to be transmitted

	DPRINT("create name objects");
	Name	a("alpha"),		// objects contained in list
		b("beta"),
		c("gamma");

	DPRINT("add objects to testlist");
	testlist.add(&a);		// put objects in list
	testlist.add(&b);
	testlist.add(&c);

	DPRINT("output testlist");
	cout << testlist;		// that's it!!!

	DPRINT("All done!");

	exit(0);
}
